(* Copyright (c) 1994-2001, Enigon Software
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list
  of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
- Neither the name of Enigon Software nor the names of its contributors may be
  used to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-- end of licence --
Author: tfrey@enigon.com
Compiled version of Raily 2.0 can be found at http://www.enigon.com/museum *)
unit SelectDirDLG;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TSelectDirForm = class(TForm)
    TreeView1: TTreeView;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ImageList1: TImageList;
    Label1: TLabel;
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure TreeView1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: boolean);
    procedure TreeView1Collapsed(Sender: TObject; Node: TTreeNode);
    procedure BaumEinlesen;
    procedure FillTree(n : TTreeNode);
    procedure FormShow(Sender: TObject);
  private
    { private-Deklarationen }
  public
    { public-Deklarationen }
  end;

var
  SelectDirForm: TSelectDirForm;

implementation

{$R *.DFM}

function getdirstr(Node:TTreeNode):string;
var s:string;
    nx: TTreeNode;
begin
    result := '';
    if Node = nil then exit;
    s := Node.text;
    nx := Node;
    while nx.parent <> nil do begin
          nx := nx.parent;
          s := nx.text + '\' + s;
    end;
    result := s + '\';
end;


procedure TSelectDirForm.BaumEinlesen;
var     nc : TTreeNode;
        i,typ : integer;
        s :string;
begin
    TreeView1.items.clear;
    for i := 0 To 25 do  begin
        s :=  Chr(i + 65) + ':\';
        typ := GetDriveType(PChar(s));
        if typ <> 0 then case typ of
          DRIVE_REMOVABLE : begin
                              nc := TreeView1.items.AddChild(nil,Chr(i + 65) + ':');
                              nc.imageindex := 4;
                              nc.selectedindex := 4;
                              TreeView1.items.AddChild(nc,'y');
                            end;
          DRIVE_FIXED     : begin
                              nc := TreeView1.items.AddChild(nil,Chr(i + 65) + ':');
                              nc.imageindex := 1;
                              nc.selectedindex := 1;
                              TreeView1.items.AddChild(nc,'y');
                            end;
          DRIVE_CDROM     : begin
                              nc := TreeView1.items.AddChild(nil,Chr(i + 65) + ':');
                              nc.imageindex := 2;
                              nc.selectedindex := 2;
                              TreeView1.items.AddChild(nc,'y');
                            end;
          DRIVE_RAMDISK   : begin
                              nc := TreeView1.items.AddChild(nil,Chr(i + 65) + ':');
                              nc.imageindex := 1;
                              nc.selectedindex := 1;
                              TreeView1.items.AddChild(nc,'y');
                            end;
          DRIVE_REMOTE    : begin
                              nc := TreeView1.items.AddChild(nil,Chr(i + 65) + ':');
                              nc.imageindex := 3;
                              nc.selectedindex := 3;
                              TreeView1.items.AddChild(nc,'y');
                            end;
        end;
    end;
end;

function HasModules(x:string):boolean;
var    search : TSearchrec;
begin
  result:= findfirst(x + '\*.mdl',faAnyFile,search)=0;
  FindClose(search);
end;

procedure TSelectDirForm.FillTree(n : TTreeNode);
var path : string;
    search : TSearchrec;
    nc : TTreeNode;

begin
     if n = nil then exit;
     path := getdirstr(n);
       if findfirst(path + '*.*',faDirectory,search) = 0 then repeat
          if ((search.attr and faDirectory)=faDirectory)and(search.name <> '.')and(search.name <> '..') then begin
            nc := TreeView1.items.AddChild(n,search.name);
            nc.imageindex := 0;
            nc.selectedindex := 0;
            if HasModules(path+search.name) then begin
              nc.imageindex := 7;
              nc.selectedindex := 7;
            end;
            TreeView1.items.AddChild(nc,'y');
          end;
       until findnext(search)<>0;
       FindClose(search);
end;

procedure TSelectDirForm.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
   Label1.caption := getdirstr(Node);
end;

procedure TSelectDirForm.TreeView1Collapsed(Sender: TObject; Node: TTreeNode);
begin
   if Node.parent = nil then exit;
   if Node.selectedindex=6 then begin
     Node.selectedindex := 7;
     Node.imageindex := 7;
   end else begin
     Node.selectedindex := 0;
     Node.imageindex := 0;
   end;
end;

procedure TSelectDirForm.TreeView1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: boolean);
begin
  Screen.Cursor := crHourglass;
try
   TreeView1.items.BeginUpdate;
   Node.DeleteChildren;
   FillTree(Node);
   TreeView1.items.EndUpdate;
   if Node.parent = nil then exit;
   if Node.selectedindex=7 then begin
     Node.selectedindex := 6;
     Node.imageindex := 6;
   end else begin
     Node.selectedindex := 5;
     Node.imageindex := 5;
   end;
  { eine lngere Operation . }
  finally
  Screen.Cursor := crDefault;                { Normalzustand wiederherstellen. }
  end;
end;


procedure TSelectDirForm.FormShow(Sender: TObject);
begin
  BaumEinlesen;
end;



end.
